using Exferia_Aplicacion.General;
using Exferia_Aplicacion.Modelos_Listado_Filtros;
using Exferia_EntityFramework;
using Exferia_Expedientes._0_Modelos;
using Exferia_General;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Exferia_Expedientes._3_Vistas.Listados
{
    public class ABS_Listado_EPD_Actores : ABS_Listado
    {
        private Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo> g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo = new Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo>();

        //Constructor
        public ABS_Listado_EPD_Actores()
        {
            Rellenar_Columnas();
        }

        private void Rellenar_Columnas()
        {
            //id
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_EPD_Actores_Listado_Modelo.id), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(true, nameof(INTERNO_EPD_Actores_Listado_Modelo.id), "id", Enumerados.G_ENUM_TIPOSDATOS.LONG, true, 0, false, false, true, false, "", null));

            //codigo
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_EPD_Actores_Listado_Modelo.codigo), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_EPD_Actores_Listado_Modelo.codigo), "Código", Enumerados.G_ENUM_TIPOSDATOS.TEXT, false, 90, true, true, true, false, "", null));

            //nombre
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_EPD_Actores_Listado_Modelo.nombre), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_EPD_Actores_Listado_Modelo.nombre), "Nombre", Enumerados.G_ENUM_TIPOSDATOS.TEXT, false, 150, true, true, true, false, "", null));

            //fechaAlta
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_EPD_Actores_Listado_Modelo.fechaAlta), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_EPD_Actores_Listado_Modelo.fechaAlta), "Fecha Alta", Enumerados.G_ENUM_TIPOSDATOS.DATETIME, false, 70, true, false, false, false, "", null));

            //fechaBaja
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_EPD_Actores_Listado_Modelo.fechaBaja), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_EPD_Actores_Listado_Modelo.fechaBaja), "Fecha Baja", Enumerados.G_ENUM_TIPOSDATOS.DATETIME, false, 70, true, false, false, false, "", null));

            //telefono_1
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_EPD_Actores_Listado_Modelo.telefono_1), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_EPD_Actores_Listado_Modelo.telefono_1), "Teléfono 1", Enumerados.G_ENUM_TIPOSDATOS.TEXT, false, 100, true, false, false, false, "", null));

            //telefono_2
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_EPD_Actores_Listado_Modelo.telefono_2), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_EPD_Actores_Listado_Modelo.telefono_2), "Teléfono 2", Enumerados.G_ENUM_TIPOSDATOS.TEXT, false, 100, true, false, false, false, "", null));

            //telefono_3
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_EPD_Actores_Listado_Modelo.telefono_3), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_EPD_Actores_Listado_Modelo.telefono_3), "Teléfono 3", Enumerados.G_ENUM_TIPOSDATOS.TEXT, false, 100, true, false, false, false, "", null));

            //fax
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_EPD_Actores_Listado_Modelo.fax), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_EPD_Actores_Listado_Modelo.fax), "Fax", Enumerados.G_ENUM_TIPOSDATOS.TEXT, false, 100, true, false, false, false, "", null));

            //email
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_EPD_Actores_Listado_Modelo.email), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_EPD_Actores_Listado_Modelo.email), "Email", Enumerados.G_ENUM_TIPOSDATOS.TEXT, false, 100, true, false, false, false, "", null));

            //cif
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_EPD_Actores_Listado_Modelo.cif), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_EPD_Actores_Listado_Modelo.cif), "CIF/NIF", Enumerados.G_ENUM_TIPOSDATOS.TEXT, false, 100, true, false, false, false, "", null));

            //Delegacion
            INTERNO_Filtro_Relacionadas_Modelo mdl_INTERNO_Filtro_Relacionadas_Modelo_DELEGACION = new INTERNO_Filtro_Relacionadas_Modelo(nameof(INTERNO_EPD_Actores_Listado_Modelo.idDelegacion), nameof(GEN_Delegaciones), nameof(GEN_Delegaciones.id), nameof(GEN_Delegaciones.codigo), nameof(GEN_Delegaciones.descripcion), nameof(GEN_Delegaciones.fechaBorrado));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_EPD_Actores_Listado_Modelo.Delegacion), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_EPD_Actores_Listado_Modelo.Delegacion), "Delegación", Enumerados.G_ENUM_TIPOSDATOS.RELACIONADA, false, 250, true, false, false, true, "", null, false, null, mdl_INTERNO_Filtro_Relacionadas_Modelo_DELEGACION));

            //Empresa
            INTERNO_Filtro_Relacionadas_Modelo mdl_INTERNO_Filtro_Relacionadas_Modelo_EMPRESA = new INTERNO_Filtro_Relacionadas_Modelo(nameof(INTERNO_EPD_Actores_Listado_Modelo.idEmpresa), nameof(GEN_Empresas), nameof(GEN_Empresas.id), nameof(GEN_Empresas.codigo), nameof(GEN_Empresas.descripcion), nameof(GEN_Empresas.fechaBorrado));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_EPD_Actores_Listado_Modelo.Empresa), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_EPD_Actores_Listado_Modelo.Empresa), "Empresa", Enumerados.G_ENUM_TIPOSDATOS.RELACIONADA, false, 250, true, false, false, true, "", null, false, null, mdl_INTERNO_Filtro_Relacionadas_Modelo_EMPRESA));
        }

        public override List<dynamic> LISTADO()
        {
            return Registros;
        }


        public override INTERNO_OpcionesDetalle_Modelo DATOS_OPCION()
        {
            return Datos_Generales.PRV_Opciones_Buscar_Detalles(Variables.G_STR_OPCION_EPD_ACTORES);
        }

        public override string NOMBRELISTADO_ALMACENARCONFIGURACION()
        {
            return Variables.G_STR_OPCION_EPD_ACTORES;
        }

        public override Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo> LISTADO_COLUMNAS()
        {
            return g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo;
        }

        public override string ORDENACION_NOMBRECOLUMNA_PORDEFECTO()
        {
            return nameof(INTERNO_EPD_Actores_Listado_Modelo.codigo);
        }

        public override string ORDENACION_TIPO_PORDEFECTO()
        {
            return "0";
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_1()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_2()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_3()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_4()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_5()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_6()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_7()
        {
            return null;
        }

        public override List<INTERNO_ArbolSecundarioSeleccion_Modelo> LISTADO_ARBOLSECUNDARIOSELECCION()
        {
            return null;
        }

        public override List<INTERNO_Listado_Paginado_Filtro_Modelo> FILTRADO_PARAPAGINADO()
        {
            return null;
        }

        public override List<string> LISTADOCAMPOS_ENVIAR_A_MANTENIMIENTO()
        {
            return null;
        }
    }
}
